local f = CreateFrame("Frame")
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:RegisterEvent("PLAYER_REGEN_ENABLED")
f:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
f:Hide()

local youAreNext = "%s shattered for 10sec, you are next!"
local whenReady = "Apply Shattering Throw when ready!"
local cooldown = {}
local reminded = nil

f:SetScript("OnEvent", function(self, event, _, cle, _, _, source, _, _, _, _, _, _, spellId)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if spellId ~= 64382 or cle ~= "SPELL_AURA_APPLIED" or not UnitInRaid(source) then return end
		cooldown[source] = GetTime() + (5 * 60)
		local otherWarriors = nil
		for i = 1, GetNumRaidMembers() do
			local player, _, _, _, _, class = GetRaidRosterInfo(i)
			if class == "WARRIOR" then
				if not cooldown[player] or (cooldown[player] <= (GetTime() + 10)) then
					SendChatMessage(youAreNext:format(source), "WHISPER", nil, player)
					return
				end
				otherWarriors = true
			end
		end
		if otherWarriors then self:Show() end
	elseif event == "PLAYER_REGEN_ENABLED" then
		reminded = nil
		self:Hide()
	elseif not reminded then
		for i = 1, GetNumRaidMembers() do
			local player, _, _, _, _, class = GetRaidRosterInfo(i)
			if class == "WARRIOR" and (not cooldown[player] or (cooldown[player] <= (GetTime() + 10))) then
				SendChatMessage(whenReady, "WHISPER", nil, player)
				reminded = true
				break
			end
		end
	end
end)

local total = 0
f:SetScript("OnUpdate", function(self, elapsed)
	total = total + elapsed
	if total > 10 then
		for player, cd in pairs(cooldown) do
			if UnitInRaid(player) and GetTime() > cd then
				SendChatMessage(whenReady, "WHISPER", nil, player)
				self:Hide()
				break
			end
		end
		total = 0
	end
end)
